import { useState, useEffect } from "react";
import * as React from "react";

//import addData from "../utils/addData";
//import KeplerGl from "@kepler.gl/components";
import { injectComponents, PanelHeaderFactory } from '@kepler.gl/components';
import { useDispatch } from 'react-redux';
import { addDataToMap } from '@kepler.gl/actions';
import { processGeojson } from '@kepler.gl/processors';

// define custom header
const CustomHeader = () => (<div className="panel--header"></div>);

// create a factory
const myCustomHeaderFactory = () => CustomHeader;

KeplerGl = injectComponents([[PanelHeaderFactory, myCustomHeaderFactory]])

/* const dataset = {
    info: {
        id: 'my_dataset_id',
        label: 'My Dataset',
    },
    data: {
        fields: [
            { name: 'id', type: 'string' },
            { name: 'latitude', type: 'real' },
            { name: 'longitude', type: 'real' },
            { name: 'value', type: 'integer' },
        ],
        rows: [
            ['1', 37.7749, -122.4194, 100],
            ['2', 40.7128, -74.006, 200],
        ],
    },
}; */

function MapKeplerGL() {
    const [data, setData] = useState([]);
    const dispatch = useDispatch();

    const geojsonData = async (pathFile) => {
        await fetch(pathFile) // "38_MB_Lines.json"
            .then(response => {
                if (!response.ok) {
                    throw new Error('Error al cargar el archivo JSON');
                }
                return response.json();
            })
            .then(geojson => {
                const dataset = processGeojson(geojson);
                const data111 = {info: {
                    id: 'my_dataset_id_' + pathFile,
                    label: pathFile,
                    },
                    data:dataset
                }
                //setData(data111)
                setData((prevItems) => [...prevItems, data111]);
                // aqui tendriamso q añadir la configuracion de layer y añadirlo luego en config de addDataToMap
            })
    }

    useEffect(() => {
        geojsonData("aaa.geojson")
        geojsonData("38_MB_Lines.json")
    }, [])

    useEffect(() => {
        if (data) {
            //console.log("data: ", data)
            dispatch(
                addDataToMap({
                    datasets: data, // Puedes añadir más de un dataset
                    config: {}, // Configuración opcional (capas, estilos)
                    options: {}, // Opciones adicionales
                })
            );
        }

    }, [dispatch, data])

    return (
        <div className="App">
            <KeplerGl
                mapboxApiAccessToken="pk.eyJ1IjoieGNhbC1ycyIsImEiOiJjbTNlNW93ajMwYmZ6Mm5xeDgwZ3NnZXNhIn0.-CatSQsKh7t-5ZSCTQ8wtQ"
                id="map"
                width={window.innerWidth}
                height={window.innerHeight}
            />
        </div>
    );
}

export default MapKeplerGL;