/* import React from 'react';
import ReactDOM from 'react-dom/client'; */

import * as React from "react";
import ReactDOM from "react-dom/client";
import document from "global/document";

import { applyMiddleware, combineReducers, compose, createStore } from "redux";
import { connect, Provider } from "react-redux";

import keplerGlReducer, { enhanceReduxMiddleware } from "@kepler.gl/reducers";
import App from './App';

import "./assest/css/global.css";

/* import './index.css';
import App from './App';
import reportWebVitals from './reportWebVitals'; */

// create reducers
const reducers = combineReducers({
	// mount keplerGl reducer
	keplerGl: keplerGlReducer.initialState({
		uiState: {
			readOnly: false,
			currentModal: null,
		},
	}),
});

// create middlewares
const middleWares = enhanceReduxMiddleware([
	// Add other middlewares here
]);

// craeteEnhancers
const enhancers = applyMiddleware(...middleWares);

// create store
const initialState = {};
const store = createStore(reducers, initialState, compose(enhancers));

/* const mapStateToProps = (state) => state;
const dispatchToProps = (dispatch) => ({ dispatch });
const ConnectedApp = connect(mapStateToProps, dispatchToProps)(App); */

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(
	<React.StrictMode>
		<Provider store={store}>
			<App />
		</Provider>
	</React.StrictMode>
);

// If you want to start measuring performance in your app, pass a function
// to log results (for example: reportWebVitals(console.log))
// or send to an analytics endpoint. Learn more: https://bit.ly/CRA-vitals
//reportWebVitals();
